<template>
	<div class="mb-2">
		<!-- ACCIONES -->
		<div class="row">
			<div class="col-2 mb-3"><h2 class="text-principal pb-2">LEGALES</h2></div>
			<div class="col-10 row mb-2">
				<div class="col-7" v-if="accion == 'M'">
					<button
						v-if="showEnviarDGA"
						type="button"
						style="width: 100%"
						class="btn text-start mb-2 pt-1 pb-1 d-inline w-30 mx-2 mt-1"
						:class="{
							'btn-pendiente': enviarDGAEstadoPendiente,
							'btn-completo bi-check-lg': enviarDGAEstadoCumplido,
						}"
						:disabled="enviarDGAEstadoCumplido"
						@click="enviaraDGA()"
					>
						<i class="bi-1-circle px-1"></i> ENVIAR A DGA
					</button>
					<button
						v-if="showTituloDefinitivo"
						type="button"
						style="width: 100%"
						class="btn text-start mb-2 pt-1 pb-1 d-inline w-30 mx-2 mt-1"
						@click="subirTitulo()"
						:disabled="subirTituloEstadoCumplido"
						:class="{
							'btn-pendiente': subirTituloEstadoPendiente,
							'btn-completo bi-check-lg': subirTituloEstadoCumplido,
						}"
					>
						<i class="bi-2-circle"></i>
						TITULO DEFINITIVO
					</button>
				</div>
				<BotoneraEscan
					class="col-2"
					v-if="enableEscan && accion == 'M'"
					ref="botoneraEscan"
					:titulo="titulo"
					:disabled="!enableEscan"
				/>
				<div class="col-3 position-absolute end-0 me-6" role="group">
					<!-- GUARDAR -->
					<button
						type="button"
						@click="guardar()"
						class="btn btn-principal mx-2"
						:disabled="habilitarBotonGuardar"
					>
						GUARDAR
					</button>
					<!-- PREVISUALIZAR PDF -->
					<a
						v-if="typeof titulo !== 'undefined'"
						:href="
							getUrl('tituloejecutivoexptit', [
								titulo.id_titulo_ejec.toString(),
								Number(titulo?.id_estado) > 3 ? 'definitivo' : 'no_definitivo',
								titulo.nombre_pdf,
							])
						"
						title="Previsualizar PDF"
						alt="Previsualizar PDF"
						target="_blank"
						class="btn btn-grey text-light mx-2 p-0 px-1"
						:class="{ disabled: habilitarPDF }"
						:aria-disabled="habilitarPDF"
						><i class="bi bi-filetype-pdf"></i
					></a>
					<!-- BORRAR -->
					<button
						type="button"
						title="Borrar"
						alt="Borrar"
						@click="borrar()"
						class="btn btn-danger p-0 px-1"
						:disabled="!habilitarBorrarLegales"
					>
						<i class="bi bi-trash"></i>
					</button>
				</div>
			</div>
		</div>
		<!-- ID | ESTADO | FECHA | NORMATIVA | RESOLUCION -->
		<div class="row">
			<div class="col-2" v-if="accion != 'A'">
				<label for="num-titulo" class="form-label">N° de Titulo</label>
				<input
					id="num-titulo"
					type="text"
					class="form-control form-control-sm p-0 px-2"
					v-model="form.numTitulo"
					disabled="true"
					style="
						background: #00aacc !important;
						color: #fff !important;
						border: 0px !important;
						font-size: 18px !important;
						font-weight: bold !important;
					"
				/>
			</div>
			<div class="col-3" v-if="accion != 'A'">
				<label for="estado" class="form-label">Estado</label>
				<div
					id="estado"
					:class="{
						'text-danger': titulo?.id_estado == 0,
					}"
				>
					<b>{{ titulo?.d_estado }}</b>
				</div>
			</div>
			<div class="col-2">
				<label for="fecha" class="form-label">Fecha</label>
				<input
					id="fecha"
					type="date"
					class="form-control form-control-sm"
					v-model="form.fecha"
					:disabled="!enableComponent"
				/>
			</div>
			<div class="col-2" v-if="normativaAplicadaIsDefined">
				<label for="num-normativa" class="form-label">Normativa Aplicada</label>
				<span
					class="d-inline-block"
					tabindex="0"
					data-bs-toggle="tooltip"
					data-bs-placement="bottom"
					:title="form.normativaAplicada?.normativa_texto"
					ref="normativa"
				>
					<div class="input-group input-group-sm">
						<input
							id="num-normativa"
							type="text"
							class="form-control"
							:value="form.normativaAplicada?.normativa"
							disabled="true"
						/>
						<span class="fs-6 ms-2">
							<i class="bi bi-patch-question"></i>
						</span>
					</div>
				</span>
			</div>
			<!-- Resolucion Cargo Deudor -->
			<div class="col-3" v-if="resolucionIsDefined">
				<div class="row">
					<label for="resolucion" class="p-0 form-label col-12"
						>Resolucion Cargo Deudor</label
					>
					<div class="col-5 px-1 px-0">
						<input
							id="resolucion"
							type="number"
							placeholder="Número"
							class="form-control form-control-sm"
							v-model="form.resolucion.nro"
							:disabled="!enableComponent"
						/>
					</div>
					<div class="col-2 px-0 text-center" style="max-width: 10px">/</div>
					<div class="col-5 px-1">
						<input
							id="resolucion"
							type="number"
							placeholder="Año"
							class="form-control form-control-sm"
							v-model="form.resolucion.anio"
							:disabled="!enableComponent"
						/>
					</div>
				</div>
			</div>
		</div>
		<!-- DATOS PERSONA | MOTIVO | PERIODO | FECHA NOTIFICACION | NRO REMITO | FECHA RECEPCION FISCALIA -->
		<div class="row">
			<!-- Component Datos Persona -->
			<div class="col-12">
				<datos-persona
					ref="datosPersona"
					:titulo="titulo"
					:disabled="!enableComponent"
					:isLoading="isLoading"
				/>
			</div>
			<!-- Motivo -->
			<div class="col-12">
				<label for="motivo" class="form-label">Motivo de la deuda</label>
				<textarea
					id="motivo"
					style="height: 40px"
					class="form-control form-control-sm"
					v-model.trim="form.motivo"
					:disabled="!enableComponent"
				/>
			</div>
			<!-- Periodo -->
			<div class="col-6">
				<label for="num-expediente" class="p-0 form-label"
					>Periodo Reclamado
				</label>
				<input
					id="num-expediente"
					type="text"
					class="form-control form-control-sm"
					v-model="form.periodo_reclamado"
					:disabled="!enableComponent"
				/>
			</div>
			<!-- Fecha Notificación -->
			<div class="col-6">
				<label for="fechaNotificacion" class="form-label"
					>Fecha de Notificación</label
				>
				<input
					id="fechaNotificacion"
					type="date"
					class="form-control form-control-sm"
					v-model="form.fechaNotificacion"
					:disabled="!enableComponent"
				/>
			</div>
			<!-- Nro Remito -->
			<div class="col-6">
				<label for="periodo" class="form-label col-12">N° de remito</label>
				<input
					type="text"
					class="form-control form-control-sm"
					v-model="form.numRemito"
					:disabled="!showRecepcionFiscalia"
				/>
			</div>
			<!-- Fecha recepción fiscalia -->
			<div class="col-6">
				<label for="periodo" class="form-label"
					>Fecha de recepción de fiscalía</label
				>
				<input
					type="date"
					class="form-control form-control-sm"
					v-model="form.fechaRecepcionFiscalia"
					:disabled="!showRecepcionFiscalia"
				/>
			</div>
		</div>
		<!-- EXPEDIENTES -->
		<div class="row">
			<div class="col-12 mt-3">
				<ExpedientesTitulo
					:titulo="titulo"
					:isLoading="isLoading"
					:disabled="!enableComponent"
					ref="expedientes"
				/>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { Tooltip } from "bootstrap";

import shared from "@/shared.js";
const { getUrl, isEmpty, urlApi, loading } = shared();

// Stores
import { mapState, mapStores } from "pinia";
import { useAuxFormDataStore } from "@/stores/auxFormData";
import { useTitulosStore } from "@/stores/titulos";

// Components
import DatosPersona from "./inputs/DatosPersona.vue";
import ExpedientesTitulo from "./ExpedientesTitulo.vue";
import BotoneraEscan from "./escaneo/BotoneraEscan.vue";

// Entities
import { Titulo } from "@/entities/Titulo";
import type { Normativa } from "@/entities/Normativa";
import { AxiosError } from "axios";

export default defineComponent({
	name: "FormularioLegales",
	components: {
		DatosPersona,
		ExpedientesTitulo,
		BotoneraEscan,
	},
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
		isLoading: {
			type: Boolean,
			required: false,
			default: false,
		},
	},
	data() {
		return {
			form: {
				numTitulo: undefined as number | string | undefined,
				fecha: undefined as string | undefined,
				normativaAplicada: undefined as Normativa | undefined,
				resolucion: {
					id: undefined as number | undefined,
					nro: undefined as number | undefined,
					anio: undefined as number | undefined,
				},
				motivo: undefined as string | undefined,
				periodo_reclamado: "" as string | undefined,
				fechaNotificacion: undefined as string | undefined,
				fechaRecepcionFiscalia: undefined as string | undefined,
				numRemito: undefined as number | undefined,
			},
		};
	},
	computed: {
		...mapState(useAuxFormDataStore, {
			normativaVigenteDefault: "normativaVigente",
			usuarioActualiza: "usuarioActualiza",
		}),
		...mapStores(useTitulosStore),
		accion(): string {
			return typeof this.titulo === "undefined" ? "A" : "M";
		},
		normativaAplicadaIsDefined(): boolean {
			return typeof this.form.normativaAplicada !== "undefined";
		},
		resolucionIsDefined(): boolean {
			return typeof this.form.resolucion !== "undefined";
		},
		habilitarPDF(): boolean {
			return !(this.usuarioActualiza?.esLegales() && this.accion != "A");
		},
		esEstadoDifinitivo(): boolean {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) == 4;
			}
			return false;
		},
		habilitarBorrarLegales(): boolean {
			if (
				typeof this.titulo !== "undefined" &&
				typeof this.usuarioActualiza !== "undefined"
			) {
				return (
					this.accion != "A" &&
					this.usuarioActualiza.esLegales() &&
					this.titulo.id_estado.toString() == "1"
				);
			} else {
				return false;
			}
		},
		habilitarBotonGuardar(): boolean {
			if (this.enableComponent || this.esEstadoDifinitivo) {
				return false;
			}
			return true;
		},
		enableComponent(): boolean {
			if (
				typeof this.titulo !== "undefined" &&
				typeof this.usuarioActualiza !== "undefined"
			) {
				return (
					this.usuarioActualiza.esLegales() &&
					this.titulo.id_estado.toString() == "1"
				);
			}
			return true;
		},
		enableEscan(): boolean {
			if (typeof this.usuarioActualiza !== "undefined") {
				return this.usuarioActualiza.esLegales();
			}
			return true;
		},
		showEnviarDGA() {
			if (typeof this.titulo !== "undefined") {
				return (
					this.usuarioActualiza?.esLegales() &&
					(this.titulo.id_estado.toString() == "1" ||
						this.titulo.id_estado.toString() == "3")
				);
			}
			return false;
		},
		showTituloDefinitivo() {
			if (typeof this.titulo !== "undefined") {
				return (
					this.usuarioActualiza?.esLegales() &&
					Number(this.titulo.id_estado) > 2 &&
					Number(this.titulo.id_estado) <= 3
				);
			}
			return false;
		},
		showRecepcionFiscalia() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) == 4;
			}
			return false;
		},
		enviarDGAEstadoPendiente() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) < 2;
			}
			return false;
		},
		enviarDGAEstadoCumplido() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) >= 2;
			}
			return false;
		},
		subirTituloEstadoPendiente() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) <= 3;
			}
			return false;
		},
		subirTituloEstadoCumplido() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) > 3;
			}
			return false;
		},
		enviarLegalesEstadoPendiente() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) < 3;
			}
			return false;
		},
		enviarLegalesEstadoCumplido() {
			if (typeof this.titulo !== "undefined") {
				return Number(this.titulo.id_estado) >= 3;
			}
			return false;
		},
	},
	methods: {
		getUrl(path: string, params: string[] = []): string {
			return getUrl(path, params);
		},
		async formularioValido(): Promise<boolean> {
			if (isEmpty(this.form.fecha)) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar una Fecha.",
				});
				return false;
			}

			// #region VALIDAR RESOLUCION
			var resolucion = this.form.resolucion;
			if (isEmpty(resolucion.nro) || isEmpty(resolucion.anio)) {
				Swal.fire({
					text: "No se indico una resolución",
				});
				return false;
			}
			var rtaRes = await http.get(urlApi + "validarResolucion", {
				params: {
					id_acto_adm_tipo: import.meta.env.VITE_ID_ACTO_ADM_TIPO_RESOLUCION,
					id_documento_tipo: import.meta.env.VITE_ID_DOCUMENTO_TIPO_RESOLUCION,
					periodo: resolucion.anio,
					nro_documento: resolucion.nro,
				},
			});
			if (rtaRes.data.status == "error") {
				Swal.fire("La resolución ingresada no existe");
				return false;
			} else {
				this.form.resolucion.id = parseInt(rtaRes.data.res.id_documento);
			}
			// #endregion VALIDAR RESOLUCION

			if (isEmpty(this.form.normativaAplicada)) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar una normativa.",
				});
				return false;
			}

			var refs: any = this.$refs;
			var datosPersonaValido = refs.datosPersona.formIsValid();

			if (!datosPersonaValido) {
				return false;
			}

			if (isEmpty(this.form.periodo_reclamado)) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar el período reclamado.",
				});
				return false;
			}

			if (isEmpty(this.form.fechaNotificacion)) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar una fecha de notificación.",
				});
				return false;
			}

			var expedientesList = refs.expedientes.getExpedientesList();
			if (expedientesList.length == 0) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar almenos un expediente.",
				});
				return false;
			}

			return true;
		},
		async guardar() {
			// Swal.fire({
			// 	icon: "success",
			// 	text:
			// 		this.accion == "A"
			// 			? "Se dio de alta el título con N°" + 6
			// 			: "Actualización exitosa",
			// }).then(() => {
			// 	console.log(this.accion == "A");
			// 	if (this.accion == "A") {
			// 		this.$router.push({
			// 			name: "formulario",
			// 			params: { id: 6 },
			// 			replace: true,
			// 		});
			// 	}
			// });
			loading.show();
			var valid = await this.formularioValido();
			if (!valid) {
				loading.hide();
				return false;
			}
			// #region guardar
			var dataRequest = {
				accion: "" as string,
				id_titulo_ejec: undefined as number | undefined,
				fecha: "" as string | undefined,
				tipo_doc: "" as string | undefined,
				nro_doc: "" as string | undefined,
				cuit: "" as string | undefined,
				ayn_o_razon_social: "" as string | undefined,
				domicilio: "" as string | undefined,
				cp: "" as string | undefined,
				id_titulos_ejec_normativa: undefined as number | undefined,
				motivo_deuda: undefined as string | undefined,
				fecha_liquidacion: undefined as string | undefined,
				id_doc_resolucion: undefined as number | undefined,
				fecha_notific: undefined as string | undefined,
				fecha_fiscalia: undefined as string | undefined,
				nro_remito_fiscalia: undefined as number | undefined,
				id_estado: undefined as number | undefined,
				id_acto_adm_tipo: undefined as number | undefined,
				id_documento_tipo: undefined as number | undefined,
				periodo_reclamado: undefined as string | undefined,
			};
			dataRequest.accion = this.accion;
			if (this.accion == "M") {
				dataRequest.id_titulo_ejec = this.titulo?.id_titulo_ejec;
			} else if (this.accion == "A") {
				dataRequest.id_estado = 1; // Estado inicial 'Proyecto'
			}
			dataRequest.fecha = this.form.fecha;
			dataRequest.fecha_liquidacion = this.form.fecha;
			var refs: any = this.$refs;
			var datosPersona = refs.datosPersona.getData();
			if (typeof datosPersona !== "undefined") {
				dataRequest.tipo_doc = datosPersona.persona.tipo_doc;
				dataRequest.nro_doc = datosPersona.persona.nro_doc;
				dataRequest.cuit = datosPersona.cuitCuil;
				dataRequest.ayn_o_razon_social = datosPersona.nombre;
				dataRequest.domicilio = datosPersona.domicilio;
				dataRequest.cp = datosPersona.cp;
			}
			dataRequest.id_titulos_ejec_normativa =
				this.form.normativaAplicada?.id_titulos_ejec_normativa;
			dataRequest.motivo_deuda = this.form.motivo;
			dataRequest.id_doc_resolucion = this.form.resolucion.id;
			dataRequest.fecha_notific = this.form.fechaNotificacion;
			dataRequest.periodo_reclamado = this.form.periodo_reclamado;
			if (!isEmpty(this.form.fechaRecepcionFiscalia)) {
				dataRequest.fecha_fiscalia = this.form.fechaRecepcionFiscalia;
			}
			if (!isEmpty(this.form.numRemito)) {
				dataRequest.nro_remito_fiscalia = this.form.numRemito;
			}
			dataRequest.id_acto_adm_tipo =
				import.meta.env.VITE_ID_ACTO_ADM_TIPO_TITULO_EJECUTIVO;
			dataRequest.id_documento_tipo =
				import.meta.env.VITE_ID_DOCUMENTO_TIPO_TITULO_EJECUTIVO;
			// #endregion guardar
			try {
				var response = await http.post(urlApi + "edicionTitulo", dataRequest);
				var id_titulo_ejec: number = response.data.res.id;
				if (this.accion == "A") {
					await refs.expedientes.guardarTodosLosExpedientes(id_titulo_ejec);
				}
				Swal.fire({
					icon: "success",
					text:
						this.accion == "A"
							? "Se dio de alta el título con N°" + id_titulo_ejec
							: "Actualización exitosa",
				}).then(() => {
					console.log("aca", this.accion);
					if (this.accion == "A") {
						this.$router.push({
							name: "formulario",
							params: { id: id_titulo_ejec },
							replace: true,
						});
					}
				});
			} catch (error: any) {
				var mensaje: string = error.message;
				if (error instanceof AxiosError) {
					mensaje = error.response?.data.res.mensaje;
				}
				Swal.fire({
					icon: "error",
					text: mensaje,
				});
			}
			loading.hide();
		},
		borrar() {
			Swal.fire({
				title: "Esta seguro de eliminar ?",
				text: "Esta accion no puede ser revertida!",
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#3085d6",
				cancelButtonColor: "#d33",
				confirmButtonText: "Eliminar",
			}).then(async (result: { isConfirmed: any }) => {
				if (result.isConfirmed) {
					loading.show();
					if (typeof this.titulo === "undefined") {
						Swal.fire({
							icon: "error",
							text: "Debe indicar un título ejecutivo",
						});
						return false;
					}
					await http.post(urlApi + "edicionTitulo", {
						accion: "B",
						id_titulo_ejec: this.titulo.id_titulo_ejec,
					});
					loading.hide();
					Swal.fire({
						icon: "success",
						text: "Se borro el título",
					}).then(() => {
						this.$router.push({ name: "listado" });
					});
				}
			});
		},
		initForm() {
			var refs: any = this.$refs;
			refs.datosPersona.initForm();
			this.form.normativaAplicada = this.normativaVigenteDefault;
			this.form.numTitulo = "Será definido al guardar el título.";
			this.form.fecha = undefined;
			this.form.resolucion = {
				id: undefined,
				nro: undefined,
				anio: undefined,
			};
			this.form.motivo =
				"Desempeñarse en dos cargos simultáneos en la Administración Pública, Nacional, Provincial y/o Municipal";
			this.form.periodo_reclamado = undefined;
			this.form.fechaNotificacion = undefined;
			this.form.fechaRecepcionFiscalia = undefined;
			this.form.numRemito = undefined;
		},
		enviaraDGA() {
			var refs: any = this.$refs;
			var expedientesList = refs.expedientes.getExpedientesList();
			if (expedientesList.length == 0) {
				Swal.fire({
					text: "Debe indicar al menos un expediente",
					icon: "error",
				});
				return false;
			}

			Swal.fire({
				title: "Esta seguro de enviar a la DGA?",
				text: "Esta accion no puede ser revertida!",
				icon: "warning",
				showCancelButton: true,
				confirmButtonColor: "#3085d6",
				cancelButtonColor: "#d33",
				confirmButtonText: "Confirmar",
			}).then(async (result) => {
				if (result.isConfirmed) {
					loading.show();
					var rta: boolean = await this.titulosStore.cambiarEstadoTitulo(
						this.titulo,
						2
					);
					loading.hide();
					if (rta) {
						Swal.fire({
							icon: "success",
							text: "Se envío el título a la DGA.",
						}).then(() => {
							this.$router.push({ name: "listado" });
						});
					} else {
						Swal.fire({
							icon: "error",
							text: "Ocurrio un error, pruebe intentar nuevamente.",
						});
					}
				}
			});
		},
		async subirTitulo() {
			if (typeof this.titulo !== "undefined") {
				const definitivo = "definitivo";
				var routeFile: string = this.getUrl("tituloejecutivoexptit", [
					String(this.titulo.id_titulo_ejec),
					definitivo,
					this.titulo.nombre_pdf,
				]);
				Swal.fire({
					title: "Título Definitivo",
					html:
						`<embed src="` +
						routeFile +
						`" type="application/pdf" width="100%" height="600px" />`,
					showCancelButton: true,
					width: "70%",
					confirmButtonColor: "#3085d6",
					cancelButtonColor: "#d33",
					confirmButtonText: "Confirmar Subir Título",
					allowOutsideClick: false,
				}).then(async (result: { isConfirmed: any }) => {
					if (result.isConfirmed) {
						Swal.fire({
							title: "¿ Esta seguro de continuar ?",
							text: "Esta accion no puede ser revertida, asegurese de haber descargado el 'Título Ejecutivo' antes de continuar.",
							icon: "warning",
							showCancelButton: true,
							confirmButtonColor: "#3085d6",
							cancelButtonColor: "#d33",
							confirmButtonText: "Confirmar",
							allowOutsideClick: false,
						}).then(async (result: { isConfirmed: any }) => {
							if (result.isConfirmed) {
								loading.show();
								const id_titulo_ejec = this.titulo?.id_titulo_ejec.toString();
								const ruta_dest =
									"/" +
									this.titulo?.directorio_destino +
									"/" +
									this.titulo?.nombre_pdf;
								// const formData = new FormData();
								// formData.append("ruta_dest", ruta_dest);
								// formData.append("id_titulo_ejec", id_titulo_ejec);
								try {
									const rta = await http.post(
										urlApi + "tituloejecutivoenviofirma",
										{
											id_titulo_ejec: id_titulo_ejec,
											ruta_dest: ruta_dest,
										}
									);
									loading.hide();
									Swal.fire({
										icon: "success",
										text: "Éxito",
										html: rta.data.message,
									}).then(() => {
										this.$router.push({ name: "listado" });
									});
								} catch (error: any) {
									var swal = {
										icon: "error",
										title: "Error",
										html: "",
									};
									if (error.response) {
										// Request made and server responded
										swal.html =
											error.message +
											" (" +
											error.code +
											")." +
											"<br />" +
											error.response.data.substring(
												error.response.data.indexOf("<h2>") + 4,
												error.response.data.indexOf("</h2>")
											);
										console.log("Error: request made and server responded");
										console.log(swal.html);
										console.log(error.response);
										//console.log(error.response.status);
										//console.log(error.response.headers);
										//console.log(error.response.data);
									} else if (error.request) {
										// The request was made but no response was received
										swal.html =
											"Error desconocido. Por favor, avise al Administrador.";
										console.log(
											"Error: the request was made but no response was received"
										);
										console.log(error.request);
									} else {
										// Something happened in setting up the request that triggered an Error
										swal.html =
											"Error desconocido. Por favor, avise al Administrador.";
										console.log(
											"Error: something happened in setting up the request that triggered an error"
										);
										console.log(error.message);
									}
									loading.hide();
									Swal.fire(swal);
								}
							}
						});
					}
				});
			} else {
				Swal.fire({
					text: "Debe indicar un título ejecutivo.",
					icon: "error",
				});
			}
		},
	},
	watch: {
		isLoading() {
			this.initForm();
			if (typeof this.titulo !== "undefined") {
				this.form.numTitulo = this.titulo.id_titulo_ejec;
				this.form.fecha = this.titulo.fecha;

				// Normativa aplicada
				this.form.normativaAplicada = {
					id_titulos_ejec_normativa: this.titulo.id_titulos_ejec_normativa,
					normativa: this.titulo.normativa,
					normativa_texto: this.titulo.normativa_texto,
				};

				// Resolucion Vigente Cargo Deudor
				this.form.resolucion.nro = this.titulo.nro_resolucion;
				this.form.resolucion.anio = this.titulo.periodo_resolucion;

				// Motivo de la deuda
				this.form.motivo =
					this.titulo.motivo_deuda != null
						? this.titulo.motivo_deuda
						: undefined;

				// Periodos
				this.form.periodo_reclamado = this.titulo.periodo_reclamado;

				// Notificación
				this.form.fechaNotificacion = this.titulo.fecha_notific;

				// Fecha recepción fiscalia
				this.form.fechaRecepcionFiscalia =
					this.titulo.fecha_fiscalia != null
						? this.titulo.fecha_fiscalia
						: undefined;

				// Número de remito
				this.form.numRemito =
					this.titulo.nro_remito_fiscalia != null
						? this.titulo.nro_remito_fiscalia
						: undefined;
			}
		},
		async normativaAplicadaIsDefined(newValue) {
			if (newValue) {
				await new Promise((r) => setTimeout(r, 50));
				new Tooltip(this.$refs.normativa);
			}
		},
	},
});
</script>

<style scoped></style>
